
/*  A Bison parser, made from alsactl_parser.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	L_TRUE	258
#define	L_FALSE	259
#define	L_INTEGER	260
#define	L_STRING	261
#define	L_BYTEARRAY	262
#define	L_DOUBLE1	263
#define	L_SOUNDCARD	264
#define	L_MIXER	265
#define	L_CHANNEL	266
#define	L_STEREO	267
#define	L_MONO	268
#define	L_SWITCH	269
#define	L_RAWDATA	270
#define	L_CONTROL	271
#define	L_PCM	272
#define	L_RAWMIDI	273
#define	L_PLAYBACK	274
#define	L_RECORD	275
#define	L_OUTPUT	276
#define	L_INPUT	277
#define	L_IEC958OCS	278
#define	L_3D	279
#define	L_RESET	280
#define	L_USER	281
#define	L_VALID	282
#define	L_DATA	283
#define	L_PROTECT	284
#define	L_PRE2	285
#define	L_FSLOCK	286
#define	L_TYPE	287
#define	L_GSTATUS	288
#define	L_ENABLE	289
#define	L_DISABLE	290
#define	L_MUTE	291
#define	L_SWOUT	292
#define	L_SWIN	293

#line 1 "alsactl_parser.y"


/*
 *  Advanced Linux Sound Architecture Control Program
 *  Copyright (c) 1998 by Perex, APS, University of South Bohemia
 *
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "alsactl.h"
#include <stdarg.h>

	/* insgus_lexer.c */

int yylex( void );

extern char cfgfile[];
extern int linecount;
extern FILE *yyin;

	/* local functions */

static void yyerror( char *, ... );

static void select_soundcard( char *name );
static void select_mixer( char *name );
static void select_pcm( char *name );
static void select_rawmidi( char *name );

static void select_mixer_channel( char *name );
static void set_mixer_channel( int left, int right );
static void set_mixer_channel_flags( unsigned int mask, unsigned int flags );
static void set_mixer_channel_end( void );

#define SWITCH_CONTROL		0
#define SWITCH_MIXER		1
#define SWITCH_PCM		2
#define SWITCH_RAWMIDI		3

static void select_control_switch( char *name );
static void select_mixer_switch( char *name );
static void select_pcm_playback_switch( char *name );
static void select_pcm_record_switch( char *name );
static void select_rawmidi_output_switch( char *name );
static void select_rawmidi_input_switch( char *name );

static void set_switch_boolean( int val );
static void set_switch_integer( int val );
static void set_switch_iec958ocs_begin( int end );
static void set_switch_iec958ocs( int idx, unsigned short val, unsigned short mask );

	/* local variables */

static struct soundcard *Xsoundcard = NULL;
static struct mixer *Xmixer = NULL;
static struct pcm *Xpcm = NULL;
static struct rawmidi *Xrawmidi = NULL;
static struct mixer_channel *Xmixerchannel = NULL;
static unsigned int Xmixerchannelflags = 0;
static int Xswitchtype = SWITCH_CONTROL;
static int *Xswitchchange = NULL;
static void *Xswitch = NULL;
static unsigned int Xswitchiec958ocs = 0;
static unsigned short Xswitchiec958ocs1[16];


#line 84 "alsactl_parser.y"
typedef union {
    int b_value;
    int i_value;
    char *s_value;
    unsigned char *a_value;
  } YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		202
#define	YYFLAG		-32768
#define	YYNTBASE	44

#define YYTRANSLATE(x) ((unsigned)(x) <= 293 ? yytranslate[x] : 95)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    39,
    43,     2,     2,    42,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    41,     2,    40,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     5,     6,     7,    16,    18,    20,    23,    28,
    29,    30,    39,    40,    41,    50,    51,    52,    61,    63,
    65,    68,    69,    77,    79,    81,    84,    85,    93,    94,
   102,   104,   106,   109,   116,   121,   123,   125,   128,   130,
   132,   134,   136,   138,   140,   142,   145,   147,   149,   151,
   153,   155,   157,   159,   162,   164,   166,   168,   170,   172,
   175,   180,   185,   187,   189,   192,   193,   201,   203,   205,
   208,   209,   217,   219,   221,   224,   229,   234,   236,   239,
   240,   248,   250,   252,   255,   256,   264,   266,   268,   271,
   273,   275,   277,   278,   279,   286,   288,   290,   293,   295,
   297,   299,   301,   303,   305,   307,   309,   311,   313,   318,
   320,   322,   324,   326,   328,   330,   332,   334,   336,   338
};

static const short yyrhs[] = {    45,
     0,    44,    45,     0,     0,     0,     9,    39,    94,    46,
     8,    48,    47,    40,     0,     1,     0,    49,     0,    48,
    49,     0,    16,    41,    56,    40,     0,     0,     0,    10,
    39,    94,    50,     8,    59,    51,    40,     0,     0,     0,
    17,    39,    94,    52,     8,    71,    53,    40,     0,     0,
     0,    18,    39,    94,    54,     8,    79,    55,    40,     0,
     1,     0,    57,     0,    56,    57,     0,     0,    14,    39,
    94,    58,    42,    87,    43,     0,     1,     0,    60,     0,
    59,    60,     0,     0,    11,    39,    94,    61,    42,    63,
    43,     0,     0,    14,    39,    94,    62,    42,    87,    43,
     0,     1,     0,    64,     0,    63,    64,     0,    12,    39,
    65,    42,    67,    43,     0,    13,    39,    69,    43,     0,
     1,     0,    66,     0,    65,    66,     0,     5,     0,    36,
     0,    20,     0,    37,     0,    38,     0,     1,     0,    68,
     0,    67,    68,     0,     5,     0,    36,     0,    20,     0,
    37,     0,    38,     0,     1,     0,    70,     0,    69,    70,
     0,     5,     0,    36,     0,    20,     0,     1,     0,    72,
     0,    71,    72,     0,    19,    41,    73,    40,     0,    20,
    41,    76,    40,     0,     1,     0,    74,     0,    73,    74,
     0,     0,    14,    39,    94,    75,    42,    87,    43,     0,
     1,     0,    77,     0,    76,    77,     0,     0,    14,    39,
    94,    78,    42,    87,    43,     0,     1,     0,    80,     0,
    79,    80,     0,    22,    41,    81,    40,     0,    21,    41,
    84,    40,     0,    82,     0,    81,    82,     0,     0,    14,
    39,    94,    83,    42,    87,    43,     0,     1,     0,    85,
     0,    84,    85,     0,     0,    14,    39,    94,    86,    42,
    87,    43,     0,     1,     0,    88,     0,    87,    88,     0,
     3,     0,     4,     0,     5,     0,     0,     0,    23,    39,
    89,    91,    90,    43,     0,     1,     0,    92,     0,    91,
    92,     0,    34,     0,    35,     0,    24,     0,    25,     0,
    26,     0,    27,     0,    28,     0,    29,     0,    30,     0,
    31,     0,    32,    39,    93,    43,     0,    33,     0,     1,
     0,     3,     0,     4,     0,     1,     0,     5,     0,     1,
     0,     6,     0,     1,     0,     7,     0,     1,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   115,   116,   119,   119,   120,   120,   123,   124,   127,   128,
   128,   129,   129,   129,   130,   130,   130,   131,   131,   134,
   135,   138,   138,   139,   142,   143,   146,   146,   147,   147,
   148,   151,   152,   155,   156,   157,   160,   161,   164,   165,
   166,   167,   168,   169,   172,   173,   176,   177,   178,   179,
   180,   181,   184,   185,   188,   189,   190,   191,   194,   195,
   198,   199,   200,   203,   204,   207,   207,   208,   211,   212,
   215,   215,   216,   219,   220,   223,   224,   227,   228,   231,
   231,   232,   235,   236,   239,   239,   240,   243,   244,   247,
   248,   249,   250,   250,   251,   251,   254,   255,   258,   259,
   260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
   270,   273,   274,   275,   278,   279,   282,   283,   286,   287
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","L_TRUE",
"L_FALSE","L_INTEGER","L_STRING","L_BYTEARRAY","L_DOUBLE1","L_SOUNDCARD","L_MIXER",
"L_CHANNEL","L_STEREO","L_MONO","L_SWITCH","L_RAWDATA","L_CONTROL","L_PCM","L_RAWMIDI",
"L_PLAYBACK","L_RECORD","L_OUTPUT","L_INPUT","L_IEC958OCS","L_3D","L_RESET",
"L_USER","L_VALID","L_DATA","L_PROTECT","L_PRE2","L_FSLOCK","L_TYPE","L_GSTATUS",
"L_ENABLE","L_DISABLE","L_MUTE","L_SWOUT","L_SWIN","'('","'}'","'{'","','","')'",
"lines","line","@1","@2","soundcards","soundcard","@3","@4","@5","@6","@7","@8",
"controls","control","@9","mixers","mixer","@10","@11","mvalues","mvalue","xmchls",
"xmchl","xmchrs","xmchr","xmchs","xmch","pcms","pcm","playbacks","playback",
"@12","records","record","@13","rawmidis","rawmidi","inputs","input","@14","outputs",
"output","@15","switches","switch","@16","@17","iec958ocs","iec958ocs1","integer",
"string", NULL
};
#endif

static const short yyr1[] = {     0,
    44,    44,    46,    47,    45,    45,    48,    48,    49,    50,
    51,    49,    52,    53,    49,    54,    55,    49,    49,    56,
    56,    58,    57,    57,    59,    59,    61,    60,    62,    60,
    60,    63,    63,    64,    64,    64,    65,    65,    66,    66,
    66,    66,    66,    66,    67,    67,    68,    68,    68,    68,
    68,    68,    69,    69,    70,    70,    70,    70,    71,    71,
    72,    72,    72,    73,    73,    75,    74,    74,    76,    76,
    78,    77,    77,    79,    79,    80,    80,    81,    81,    83,
    82,    82,    84,    84,    86,    85,    85,    87,    87,    88,
    88,    88,    89,    90,    88,    88,    91,    91,    92,    92,
    92,    92,    92,    92,    92,    92,    92,    92,    92,    92,
    92,    -1,    -1,    -1,    93,    93,    94,    94,    -1,    -1
};

static const short yyr2[] = {     0,
     1,     2,     0,     0,     8,     1,     1,     2,     4,     0,
     0,     8,     0,     0,     8,     0,     0,     8,     1,     1,
     2,     0,     7,     1,     1,     2,     0,     7,     0,     7,
     1,     1,     2,     6,     4,     1,     1,     2,     1,     1,
     1,     1,     1,     1,     1,     2,     1,     1,     1,     1,
     1,     1,     1,     2,     1,     1,     1,     1,     1,     2,
     4,     4,     1,     1,     2,     0,     7,     1,     1,     2,
     0,     7,     1,     1,     2,     4,     4,     1,     2,     0,
     7,     1,     1,     2,     0,     7,     1,     1,     2,     1,
     1,     1,     0,     0,     6,     1,     1,     2,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     4,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1
};

static const short yydefact[] = {     0,
     6,     0,     0,     1,     0,     2,   118,   117,     3,     0,
     0,    19,     0,     0,     0,     0,     0,     7,     0,     0,
     0,     0,     0,     8,    10,    24,     0,     0,    20,    13,
    16,     5,     0,     0,     9,    21,     0,     0,     0,    22,
     0,     0,    31,     0,     0,     0,    25,     0,    63,     0,
     0,     0,    59,     0,     0,    17,    74,     0,     0,     0,
    26,     0,     0,     0,     0,    60,     0,     0,     0,    75,
    27,    29,    12,    96,    90,    91,    92,     0,     0,    88,
    68,     0,     0,    64,    73,     0,     0,    69,    15,    87,
     0,     0,    83,    82,     0,     0,    78,    18,     0,     0,
    93,    23,    89,     0,    61,    65,     0,    62,    70,     0,
    77,    84,     0,    76,    79,     0,     0,     0,    66,    71,
    85,    80,    36,     0,     0,     0,    32,     0,   111,   101,
   102,   103,   104,   105,   106,   107,   108,     0,   110,    99,
   100,     0,    97,     0,     0,     0,     0,     0,     0,    28,
    33,    30,     0,     0,    98,     0,     0,     0,     0,    44,
    39,    41,    40,    42,    43,     0,    37,    58,    55,    57,
    56,     0,    53,   116,   115,     0,    95,     0,     0,     0,
     0,     0,    38,    35,    54,   109,    67,    72,    86,    81,
    52,    47,    49,    48,    50,    51,     0,    45,    34,    46,
     0,     0
};

static const short yydefgoto[] = {     3,
     4,    10,    23,    17,    18,    33,    60,    37,    65,    38,
    69,    28,    29,    48,    46,    47,    99,   100,   126,   127,
   166,   167,   197,   198,   172,   173,    52,    53,    83,    84,
   144,    87,    88,   145,    56,    57,    96,    97,   147,    92,
    93,   146,    79,    80,   118,   154,   142,   143,   176,     9
};

static const short yypact[] = {   184,
-32768,   -30,     6,-32768,     7,-32768,-32768,-32768,-32768,    30,
   165,-32768,     3,    20,    18,    19,   113,-32768,     7,    74,
     7,     7,    23,-32768,-32768,-32768,    25,   121,-32768,-32768,
-32768,-32768,    75,     7,-32768,-32768,    76,    86,   157,-32768,
     4,   -10,-32768,    43,    48,   123,-32768,    67,-32768,    69,
    71,   107,-32768,    95,   115,   -10,-32768,     7,     7,   148,
-32768,   139,    79,   156,   161,-32768,   172,   175,   162,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   155,    16,-32768,
-32768,   176,   127,-32768,-32768,   177,   132,-32768,-32768,-32768,
   178,   137,-32768,-32768,   180,   138,-32768,-32768,   181,   182,
-32768,-32768,-32768,     7,-32768,-32768,     7,-32768,-32768,     7,
-32768,-32768,     7,-32768,-32768,   186,   139,   179,-32768,-32768,
-32768,-32768,-32768,   183,   187,    55,-32768,    42,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   188,-32768,-32768,
-32768,     1,-32768,   189,   190,   191,   192,   154,   164,-32768,
-32768,-32768,     9,    72,-32768,   139,   139,   139,   139,-32768,
-32768,-32768,-32768,-32768,-32768,   112,-32768,-32768,-32768,-32768,
-32768,    61,-32768,-32768,-32768,   185,-32768,    47,    68,    73,
   102,   159,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,    17,-32768,-32768,-32768,
   218,-32768
};

static const short yypgoto[] = {-32768,
   217,-32768,-32768,-32768,   204,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   197,-32768,-32768,   193,-32768,-32768,-32768,   103,
-32768,    64,-32768,    38,-32768,    65,-32768,   194,-32768,   153,
-32768,-32768,   151,-32768,-32768,   195,-32768,   144,-32768,-32768,
   149,-32768,   -38,   -79,-32768,-32768,-32768,   100,-32768,   -18
};


#define	YYLAST		251


static const short yytable[] = {   103,
    25,   129,    30,    31,    49,   201,     1,     7,     5,   174,
    54,    55,     8,   175,     2,    40,    74,   191,    75,    76,
    77,   192,    50,    51,   130,   131,   132,   133,   134,   135,
   136,   137,   138,   139,   140,   141,   193,    11,    78,    71,
    72,    19,    74,   -94,    75,    76,    77,    74,   103,    75,
    76,    77,   194,   195,   196,   123,    21,    22,   102,   199,
    20,   168,    32,    34,    78,   169,   124,   125,    74,    78,
    75,    76,    77,    74,    26,    75,    76,    77,   128,    81,
   170,    58,    39,    41,   152,   119,    59,    27,   120,   187,
    78,   121,    82,    42,   122,    78,   171,   150,   103,   103,
   103,   103,    74,   184,    75,    76,    77,    49,    62,    63,
   188,    64,   160,    12,   177,   189,   161,   178,   179,   180,
   181,    26,    13,    43,    78,    50,    51,    81,    14,    15,
    16,   162,    85,    44,    27,    67,    45,    90,    94,    74,
    82,    75,    76,    77,   190,    86,   -14,   163,   164,   165,
    91,    95,    -4,   182,   160,    68,    85,    43,   161,   191,
    35,    78,   -11,   192,   168,    12,   105,    44,   169,    86,
    45,   108,    90,   162,    13,    94,   111,   114,   193,   129,
    14,    15,    16,   170,     1,    91,   123,    73,    95,   163,
   164,   165,     2,   101,   194,   195,   196,   124,   125,   171,
    89,    98,   130,   131,   132,   133,   134,   135,   136,   137,
   138,   139,   140,   141,   104,   107,   110,   202,   113,     6,
    24,   148,   116,   117,    36,   149,   153,   186,   151,   183,
   156,   157,   158,   159,   200,   106,   185,   109,    61,   115,
   112,   155,     0,     0,     0,    66,     0,     0,     0,     0,
    70
};

static const short yycheck[] = {    79,
    19,     1,    21,    22,     1,     0,     1,     1,    39,     1,
    21,    22,     6,     5,     9,    34,     1,     1,     3,     4,
     5,     5,    19,    20,    24,    25,    26,    27,    28,    29,
    30,    31,    32,    33,    34,    35,    20,     8,    23,    58,
    59,    39,     1,    43,     3,     4,     5,     1,   128,     3,
     4,     5,    36,    37,    38,     1,    39,    39,    43,    43,
    41,     1,    40,    39,    23,     5,    12,    13,     1,    23,
     3,     4,     5,     1,     1,     3,     4,     5,   117,     1,
    20,    39,     8,     8,    43,   104,    39,    14,   107,    43,
    23,   110,    14,     8,   113,    23,    36,    43,   178,   179,
   180,   181,     1,    43,     3,     4,     5,     1,    42,    41,
    43,    41,     1,     1,    43,    43,     5,   156,   157,   158,
   159,     1,    10,     1,    23,    19,    20,     1,    16,    17,
    18,    20,     1,    11,    14,    41,    14,     1,     1,     1,
    14,     3,     4,     5,    43,    14,    40,    36,    37,    38,
    14,    14,    40,    42,     1,    41,     1,     1,     5,     1,
    40,    23,    40,     5,     1,     1,    40,    11,     5,    14,
    14,    40,     1,    20,    10,     1,    40,    40,    20,     1,
    16,    17,    18,    20,     1,    14,     1,    40,    14,    36,
    37,    38,     9,    39,    36,    37,    38,    12,    13,    36,
    40,    40,    24,    25,    26,    27,    28,    29,    30,    31,
    32,    33,    34,    35,    39,    39,    39,     0,    39,     3,
    17,    39,    42,    42,    28,    39,    39,    43,   126,   166,
    42,    42,    42,    42,   197,    83,   172,    87,    46,    96,
    92,   142,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,
    56
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

#ifndef YYPARSE_RETURN_TYPE
#define YYPARSE_RETURN_TYPE int
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
YYPARSE_RETURN_TYPE yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 196 "/usr/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

YYPARSE_RETURN_TYPE
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 3:
#line 119 "alsactl_parser.y"
{ select_soundcard( yyvsp[0].s_value ); ;
    break;}
case 4:
#line 119 "alsactl_parser.y"
{ select_soundcard( NULL ); ;
    break;}
case 6:
#line 120 "alsactl_parser.y"
{ yyerror( "unknown keyword in top level" ); ;
    break;}
case 10:
#line 128 "alsactl_parser.y"
{ select_mixer( yyvsp[0].s_value ); ;
    break;}
case 11:
#line 128 "alsactl_parser.y"
{ select_mixer( NULL ); ;
    break;}
case 13:
#line 129 "alsactl_parser.y"
{ select_pcm( yyvsp[0].s_value ); ;
    break;}
case 14:
#line 129 "alsactl_parser.y"
{ select_pcm( NULL ); ;
    break;}
case 16:
#line 130 "alsactl_parser.y"
{ select_rawmidi( yyvsp[0].s_value ); ;
    break;}
case 17:
#line 130 "alsactl_parser.y"
{ select_rawmidi( NULL ); ;
    break;}
case 19:
#line 131 "alsactl_parser.y"
{ yyerror( "unknown keyword in soundcard{} level" ); ;
    break;}
case 22:
#line 138 "alsactl_parser.y"
{ select_control_switch( yyvsp[0].s_value ); ;
    break;}
case 23:
#line 138 "alsactl_parser.y"
{ select_control_switch( NULL ); ;
    break;}
case 24:
#line 139 "alsactl_parser.y"
{ yyerror( "unknown keyword in control{} level" ); ;
    break;}
case 27:
#line 146 "alsactl_parser.y"
{ select_mixer_channel( yyvsp[0].s_value ); ;
    break;}
case 28:
#line 146 "alsactl_parser.y"
{ set_mixer_channel_end(); select_mixer_channel( NULL ); ;
    break;}
case 29:
#line 147 "alsactl_parser.y"
{ select_mixer_switch( yyvsp[0].s_value ); ;
    break;}
case 30:
#line 147 "alsactl_parser.y"
{ select_mixer_switch( NULL ); ;
    break;}
case 31:
#line 148 "alsactl_parser.y"
{ yyerror( "unknown keyword in mixer{} level" ); ;
    break;}
case 36:
#line 157 "alsactl_parser.y"
{ yyerror( "unknown keyword in mixer channel{} level" ); ;
    break;}
case 39:
#line 164 "alsactl_parser.y"
{ set_mixer_channel( yyvsp[0].i_value, -1 ); ;
    break;}
case 40:
#line 165 "alsactl_parser.y"
{ set_mixer_channel_flags( SND_MIXER_FLG_MUTE_LEFT, SND_MIXER_FLG_MUTE_LEFT ); ;
    break;}
case 41:
#line 166 "alsactl_parser.y"
{ set_mixer_channel_flags( SND_MIXER_FLG_RECORD_LEFT, SND_MIXER_FLG_RECORD_LEFT ); ;
    break;}
case 42:
#line 167 "alsactl_parser.y"
{ set_mixer_channel_flags( SND_MIXER_FLG_LTOR_OUT, SND_MIXER_FLG_LTOR_OUT ); ;
    break;}
case 43:
#line 168 "alsactl_parser.y"
{ set_mixer_channel_flags( SND_MIXER_FLG_LTOR_IN, SND_MIXER_FLG_LTOR_IN ); ;
    break;}
case 44:
#line 169 "alsactl_parser.y"
{ yyerror( "unknown keyword in left channel section..." ); ;
    break;}
case 47:
#line 176 "alsactl_parser.y"
{ set_mixer_channel( -1, yyvsp[0].i_value ); ;
    break;}
case 48:
#line 177 "alsactl_parser.y"
{ set_mixer_channel_flags( SND_MIXER_FLG_MUTE_RIGHT, SND_MIXER_FLG_MUTE_RIGHT ); ;
    break;}
case 49:
#line 178 "alsactl_parser.y"
{ set_mixer_channel_flags( SND_MIXER_FLG_RECORD_RIGHT, SND_MIXER_FLG_RECORD_RIGHT ); ;
    break;}
case 50:
#line 179 "alsactl_parser.y"
{ set_mixer_channel_flags( SND_MIXER_FLG_RTOL_OUT, SND_MIXER_FLG_RTOL_OUT ); ;
    break;}
case 51:
#line 180 "alsactl_parser.y"
{ set_mixer_channel_flags( SND_MIXER_FLG_RTOL_IN, SND_MIXER_FLG_RTOL_IN ); ;
    break;}
case 52:
#line 181 "alsactl_parser.y"
{ yyerror( "unknown keyword in right channel section..." ); ;
    break;}
case 55:
#line 188 "alsactl_parser.y"
{ set_mixer_channel( yyvsp[0].i_value, yyvsp[0].i_value ); ;
    break;}
case 56:
#line 189 "alsactl_parser.y"
{ set_mixer_channel_flags( SND_MIXER_FLG_MUTE, SND_MIXER_FLG_MUTE ); ;
    break;}
case 57:
#line 190 "alsactl_parser.y"
{ set_mixer_channel_flags( SND_MIXER_FLG_RECORD, SND_MIXER_FLG_RECORD ); ;
    break;}
case 58:
#line 191 "alsactl_parser.y"
{ yyerror( "unknown keyword in mono channel section..." ); ;
    break;}
case 63:
#line 200 "alsactl_parser.y"
{ yyerror( "unknown keyword in pcm{} section" ); ;
    break;}
case 66:
#line 207 "alsactl_parser.y"
{ select_pcm_playback_switch( yyvsp[0].s_value ); ;
    break;}
case 67:
#line 207 "alsactl_parser.y"
{ select_pcm_playback_switch( NULL ); ;
    break;}
case 68:
#line 208 "alsactl_parser.y"
{ yyerror( "unknown keyword in playback{} section" ); ;
    break;}
case 71:
#line 215 "alsactl_parser.y"
{ select_pcm_record_switch( yyvsp[0].s_value ); ;
    break;}
case 72:
#line 215 "alsactl_parser.y"
{ select_pcm_record_switch( NULL ); ;
    break;}
case 73:
#line 216 "alsactl_parser.y"
{ yyerror( "unknown keyword in record{} section" ); ;
    break;}
case 80:
#line 231 "alsactl_parser.y"
{ select_rawmidi_input_switch( yyvsp[0].s_value ); ;
    break;}
case 81:
#line 231 "alsactl_parser.y"
{ select_rawmidi_input_switch( NULL ); ;
    break;}
case 82:
#line 232 "alsactl_parser.y"
{ yyerror( "unknown keyword in input{} section" ); ;
    break;}
case 85:
#line 239 "alsactl_parser.y"
{ select_rawmidi_output_switch( yyvsp[0].s_value ); ;
    break;}
case 86:
#line 239 "alsactl_parser.y"
{ select_rawmidi_output_switch( NULL ); ;
    break;}
case 87:
#line 240 "alsactl_parser.y"
{ yyerror( "unknown keyword in output{} section" ); ;
    break;}
case 90:
#line 247 "alsactl_parser.y"
{ set_switch_boolean( 1 ); ;
    break;}
case 91:
#line 248 "alsactl_parser.y"
{ set_switch_boolean( 0 ); ;
    break;}
case 92:
#line 249 "alsactl_parser.y"
{ set_switch_integer( yyvsp[0].i_value ); ;
    break;}
case 93:
#line 250 "alsactl_parser.y"
{ set_switch_iec958ocs_begin( 0 ); ;
    break;}
case 94:
#line 250 "alsactl_parser.y"
{ set_switch_iec958ocs_begin( 1 ); ;
    break;}
case 96:
#line 251 "alsactl_parser.y"
{ yyerror( "unknown keyword in switch() data parameter" ); ;
    break;}
case 99:
#line 258 "alsactl_parser.y"
{ set_switch_iec958ocs( 0, 1, 0 ); ;
    break;}
case 100:
#line 259 "alsactl_parser.y"
{ set_switch_iec958ocs( 0, 0, 0 ); ;
    break;}
case 101:
#line 260 "alsactl_parser.y"
{ set_switch_iec958ocs( 4, 0x2000, ~0x2000 ); ;
    break;}
case 102:
#line 261 "alsactl_parser.y"
{ set_switch_iec958ocs( 4, 0x0040, ~0x0040 ); ;
    break;}
case 103:
#line 262 "alsactl_parser.y"
{ set_switch_iec958ocs( 4, 0x0020, ~0x0020 ); ;
    break;}
case 104:
#line 263 "alsactl_parser.y"
{ set_switch_iec958ocs( 4, 0x0010, ~0x0010 ); ;
    break;}
case 105:
#line 264 "alsactl_parser.y"
{ set_switch_iec958ocs( 5, 0x0002, ~0x0002 ); ;
    break;}
case 106:
#line 265 "alsactl_parser.y"
{ set_switch_iec958ocs( 5, 0x0004, ~0x0004 ); ;
    break;}
case 107:
#line 266 "alsactl_parser.y"
{ set_switch_iec958ocs( 5, 0x0008, ~0x0018 ); ;
    break;}
case 108:
#line 267 "alsactl_parser.y"
{ set_switch_iec958ocs( 5, 0x0020, ~0x0020 ); ;
    break;}
case 109:
#line 268 "alsactl_parser.y"
{ set_switch_iec958ocs( 5, (yyvsp[-1].i_value & 0x7f) << 6, ~(0x7f<<6) ); ;
    break;}
case 110:
#line 269 "alsactl_parser.y"
{ set_switch_iec958ocs( 5, 0x2000, ~0x2000 ); ;
    break;}
case 111:
#line 270 "alsactl_parser.y"
{ yyerror( "unknown keyword in iec958ocs1() arguments" ); ;
    break;}
case 112:
#line 273 "alsactl_parser.y"
{ yyval.b_value = 1; ;
    break;}
case 113:
#line 274 "alsactl_parser.y"
{ yyval.b_value = 0; ;
    break;}
case 114:
#line 275 "alsactl_parser.y"
{ yyerror( "unknown boolean value" ); ;
    break;}
case 115:
#line 278 "alsactl_parser.y"
{ yyval.i_value = yyvsp[0].i_value; ;
    break;}
case 116:
#line 279 "alsactl_parser.y"
{ yyerror( "unknown integer value" ); ;
    break;}
case 117:
#line 282 "alsactl_parser.y"
{ yyval.s_value = yyvsp[0].s_value; ;
    break;}
case 118:
#line 283 "alsactl_parser.y"
{ yyerror( "unknown string value" ); ;
    break;}
case 119:
#line 286 "alsactl_parser.y"
{ yyval.a_value = yyvsp[0].a_value; ;
    break;}
case 120:
#line 287 "alsactl_parser.y"
{ yyerror( "unknown byte array value" ); ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 498 "/usr/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 290 "alsactl_parser.y"


static void yyerror( char *string, ... )
{
  char errstr[ 1024 ];

  va_list vars;
  va_start( vars, string );
  vsprintf( errstr, string, vars );
  va_end( vars );
  error( "Error in configuration file '%s' (line %i): %s", cfgfile, linecount + 1, errstr );

  exit( 1 );
}

static void select_soundcard( char *name )
{
  struct soundcard *soundcard;

  if ( !name ) { Xsoundcard = NULL; return; }
  for ( soundcard = soundcards; soundcard; soundcard = soundcard -> next )
    if ( !strcmp( soundcard -> control.hwinfo.id, name ) ) {
      Xsoundcard = soundcard;
      free( name );
      return;
    }
  yyerror( "Cannot find soundcard '%s'...", name ); 
  free( name );
}

static void select_mixer( char *name )
{
  struct mixer *mixer;

  if ( !name ) { Xmixer = NULL; return; }
  for ( mixer = Xsoundcard -> mixers; mixer; mixer = mixer -> next )
    if ( !strcmp( mixer -> info.name, name ) ) {
      Xmixer = mixer;
      free( name );
      return;
    }
  yyerror( "Cannot find mixer '%s' for soundcard '%s'...", name, Xsoundcard -> control.hwinfo.id );
  free( name );
}

static void select_pcm( char *name )
{
  struct pcm *pcm;

  if ( !name ) { Xpcm = NULL; return; }
  for ( pcm = Xsoundcard -> pcms; pcm; pcm = pcm -> next )
    if ( !strcmp( pcm -> info.name, name ) ) {
      Xpcm = pcm;
      free( name );
      return;
    }
  yyerror( "Cannot find pcm device '%s' for soundcard '%s'...", name, Xsoundcard -> control.hwinfo.id );
  free( name );
}

static void select_rawmidi( char *name )
{
  struct rawmidi *rawmidi;

  if ( !name ) { Xrawmidi = NULL; return; }
  for ( rawmidi = Xsoundcard -> rawmidis; rawmidi; rawmidi = rawmidi -> next )
    if ( !strcmp( rawmidi -> info.name, name ) ) {
      Xrawmidi = rawmidi;
      free( name );
      return;
    }
  yyerror( "Cannot find rawmidi device '%s' for soundcard '%s'...", name, Xsoundcard -> control.hwinfo.id );
  free( name );
}

static void select_mixer_channel( char *name )
{
  struct mixer_channel *channel;

  if ( !name ) { Xmixerchannel = NULL; return; }
  for ( channel = Xmixer -> channels; channel; channel = channel -> next )
    if ( !strcmp( channel -> i.name, name ) ) {
      Xmixerchannel = channel;
      Xmixerchannelflags = Xmixerchannel -> c.flags & 
				~(SND_MIXER_FLG_RECORD |
			  	  SND_MIXER_FLG_MUTE |
			  	  SND_MIXER_FLG_SWITCH_OUT |
			  	  SND_MIXER_FLG_SWITCH_IN |
			  	  SND_MIXER_FLG_DECIBEL |
			  	  SND_MIXER_FLG_FORCE);
      free( name );
      return;
    }
  yyerror( "Cannot find mixer channel '%s'...", name );
  free( name );
}

static void set_mixer_channel( int left, int right )
{
  if ( left >= 0 ) {
    if ( Xmixerchannel -> i.min > left || Xmixerchannel -> i.max < left )
      yyerror( "Value out of range (%i-%i)...", Xmixerchannel -> i.min, Xmixerchannel -> i.max );
    if ( Xmixerchannel -> c.left != left )
      Xmixerchannel -> change = 1;
    Xmixerchannel -> c.left = left;
  }
  if ( right >= 0 ) {
    if ( Xmixerchannel -> i.min > right || Xmixerchannel -> i.max < right )
      yyerror( "Value out of range (%i-%i)...", Xmixerchannel -> i.min, Xmixerchannel -> i.max );
    if ( Xmixerchannel -> c.right != right )
      Xmixerchannel -> change = 1;
    Xmixerchannel -> c.right = right;
  }
}

static void set_mixer_channel_flags( unsigned int mask, unsigned int flags )
{
  Xmixerchannelflags &= ~mask;
  Xmixerchannelflags |= flags;
}

static void set_mixer_channel_end( void )
{
  if ( Xmixerchannel -> c.flags != Xmixerchannelflags ) {
    Xmixerchannel -> change = 1;
  }
  Xmixerchannel -> c.flags = Xmixerchannelflags;
}

#define FIND_SWITCH( xtype, first, name, err ) \
  if ( !name ) { Xswitch = Xswitchchange = NULL; return; } \
  for ( sw = first; sw; sw = sw -> next ) { \
    if ( !strcmp( sw -> s.name, name ) ) { \
      Xswitchtype = xtype; \
      Xswitchchange = &sw -> change; \
      Xswitch = (void *)&sw -> s; \
      free( name ); \
      return; \
    } \
  } \
  yyerror( "Cannot find " err " switch '%s'...", name ); \
  free( name );

static void select_control_switch( char *name )
{
  struct ctl_switch *sw;
  FIND_SWITCH( SWITCH_CONTROL, Xsoundcard -> control.switches, name, "control" );
}

static void select_mixer_switch( char *name )
{
  struct mixer_switch *sw;
  FIND_SWITCH( SWITCH_MIXER, Xmixer -> switches, name, "mixer" );
}

static void select_pcm_playback_switch( char *name )
{
  struct pcm_switch *sw;
  FIND_SWITCH( SWITCH_PCM, Xpcm -> pswitches, name, "pcm playback" );
}

static void select_pcm_record_switch( char *name )
{
  struct pcm_switch *sw;
  FIND_SWITCH( SWITCH_PCM, Xpcm -> rswitches, name, "pcm record" );
}

static void select_rawmidi_output_switch( char *name )
{
  struct rawmidi_switch *sw;
  FIND_SWITCH( SWITCH_RAWMIDI, Xrawmidi -> oswitches, name, "rawmidi output" );
}

static void select_rawmidi_input_switch( char *name )
{
  struct rawmidi_switch *sw;
  FIND_SWITCH( SWITCH_RAWMIDI, Xrawmidi -> iswitches, name, "rawmidi input" );
}

static void set_switch_boolean( int val )
{
  /* ok.. this is a little bit wrong, but at these times are all switches same */
  snd_ctl_switch_t *sw = (snd_ctl_switch_t *)Xswitch;
  unsigned int xx;

  if ( sw -> type != SND_CTL_SW_TYPE_BOOLEAN )
    yyerror( "Switch '%s' isn't boolean type...", sw -> name );
  xx = val & 1;
  if ( memcmp( &sw -> value, &xx, sizeof(xx) ) ) *Xswitchchange = 1;
  memcpy( &sw -> value, &xx, sizeof(xx) );
}

static void set_switch_integer( int val )
{
  /* ok.. this is a little bit wrong, but at these times are all switches same */
  snd_ctl_switch_t *sw = (snd_ctl_switch_t *)Xswitch;
  unsigned int xx;

  if ( sw -> type != SND_CTL_SW_TYPE_BYTE &&
       sw -> type != SND_CTL_SW_TYPE_WORD &&
       sw -> type != SND_CTL_SW_TYPE_DWORD )
    yyerror( "Switch '%s' isn't integer type...", sw -> name );
  if ( val < sw -> low || val > sw -> high )
    yyerror( "Value for switch '%s' out of range (%i-%i)...\n", sw -> name, sw -> low, sw -> high );
  xx = val;
  if ( memcmp( &sw -> value, &xx, sizeof(xx) ) ) *Xswitchchange = 1;
  memcpy( &sw -> value, &xx, sizeof(xx) );
}

static void set_switch_iec958ocs_begin( int end )
{
  /* ok.. this is a little bit wrong, but at these times are all switches same */
  snd_ctl_switch_t *sw = (snd_ctl_switch_t *)Xswitch;

  if ( !end ) {
    if ( Xswitchiec958ocs != sw -> value.enable ) {
      sw -> value.enable = Xswitchiec958ocs;
      *Xswitchchange = 1;
    }
    if ( Xswitchiec958ocs1[4] != sw -> value.data16[4] ) {
      sw -> value.data16[4] = Xswitchiec958ocs1[4];
      *Xswitchchange = 1;
    }
    if ( Xswitchiec958ocs1[5] != sw -> value.data16[5] ) {
      sw -> value.data16[5] = Xswitchiec958ocs1[5];
      *Xswitchchange = 1;
    }
    return;
  }
  if ( Xswitchtype != SWITCH_MIXER || sw -> type != SND_MIXER_SW_TYPE_BOOLEAN ||
       strcmp( sw -> name, SND_MIXER_SW_IEC958OUT ) )
    yyerror( "Switch '%s' cannot store IEC958 information for Cirrus Logic chips...", sw -> name );
  if ( sw -> value.data32[1] != (('C'<<8)|'S') )
    yyerror( "Switch '%s' doesn't have Cirrus Logic signature!!!", sw -> name );
  Xswitchiec958ocs = 0;
  Xswitchiec958ocs1[4] = 0x0000;
  Xswitchiec958ocs1[5] = 0x0000;
}

static void set_switch_iec958ocs( int idx, unsigned short val, unsigned short mask )
{
  if ( idx == 0 ) {
    Xswitchiec958ocs = val ? 1 : 0;
    return;
  }
  Xswitchiec958ocs1[ idx ] &= ~mask;
  Xswitchiec958ocs1[ idx ] |= val;
}
